#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;
namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols {
  [StorableClass]
  public sealed class DifferentialVariableTreeNode : VariableTreeNode {
    public new DifferentialVariable Symbol {
      get { return (DifferentialVariable)base.Symbol; }
    }

    [StorableConstructor]
    protected DifferentialVariableTreeNode(bool deserializing) : base(deserializing) { }
    protected DifferentialVariableTreeNode(DifferentialVariableTreeNode original, Cloner cloner)
      : base(original, cloner) {
    }
    private DifferentialVariableTreeNode() { }

    public DifferentialVariableTreeNode(DifferentialVariable differentialSymbol) : base(differentialSymbol) { }


    public override IDeepCloneable Clone(Cloner cloner) {
      return new DifferentialVariableTreeNode(this, cloner);
    }
  }
}
